(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     37952,        866]
NotebookOptionsPosition[     37543,        847]
NotebookOutlinePosition[     37900,        863]
CellTagsIndexPosition[     37857,        860]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "Probl\[EAcute]m 8 dam.",
 StyleBox["\n",
  FontSize->24],
 StyleBox["Autor: Radek Jire\[SHacek];\nKontakt: jiresrad@fit.cvut.cz", 
  "Subsubtitle",
  FontFamily->"Nimbus Sans L"]
}], "Title",
 CellChangeTimes->{{3.528565051030175*^9, 3.528565079519859*^9}, {
  3.528565146552561*^9, 3.528565148089075*^9}, {3.528565204086976*^9, 
  3.528565205788667*^9}, {3.528565361066662*^9, 3.528565420490108*^9}, {
  3.528565774508001*^9, 3.52856578032481*^9}, {3.528565830679587*^9, 
  3.528565831892991*^9}, {3.528566691927592*^9, 3.528566761344815*^9}, {
  3.528886048269316*^9, 3.528886053141439*^9}, {3.528886235753624*^9, 
  3.528886236199741*^9}}],

Cell[TextData[{
 StyleBox["\[CapitalUAcute]kolem je rozm\[IAcute]stit 8 dam na \
\[SHacek]achovnici 8x8 tak, aby se \[ZHacek]\[AAcute]dn\[AAcute] neohro\
\[ZHacek]ovala.\nTento program je roz\[SHacek]\[IAcute]\[RHacek]en o hled\
\[AAcute]n\[IAcute] jak\[EAcute]koliv velikosti \[SHacek]achovnice NxN pro N \
po\[CHacek]et dam. \nPozn.", "Subsubtitle"],
 StyleBox[" ", "Subsubtitle",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox["Nutn\[EAcute] odklepnout 2x.", "Subsubtitle",
  FontColor->RGBColor[0, 0, 1],
  Background->RGBColor[1, 1, 0.85]]
}], "Subtitle",
 CellChangeTimes->{{3.528565115732804*^9, 3.528565271768863*^9}, {
  3.528566569995984*^9, 3.5285665840988*^9}}],

Cell["\<\
Tato \[UAcute]loha je kombinatorick\[YAcute] probl\[EAcute]m. Pro hled\
\[AAcute]n\[IAcute] jsem zvolil Backtrakov\[YAcute] algoritmus hled\[AAcute]n\
\[IAcute] hrubou silou.
Slo\[ZHacek]itost algoritmu je  \[CapitalOmicron](n!) Tak\[ZHacek]e pro velik\
\[EAcute] n nap\[RHacek]. 20 a v\[IAcute]ce nen\[IAcute] \
\[RHacek]e\[SHacek]iteln\[EAcute] v re\[AAcute]ln\[EAcute]m \[CHacek]ase.
\
\>", "Text",
 CellChangeTimes->{{3.528565281367484*^9, 3.52856535901172*^9}, {
  3.528565435274413*^9, 3.528565472638955*^9}, {3.528565515715945*^9, 
  3.528565626497454*^9}, {3.528565736948044*^9, 3.528565740172489*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"ZADEJ", " ", "POCET", " ", 
    RowBox[{"DAM", " ", "!!"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   StyleBox[
    RowBox[{
     RowBox[{"n", "=", "8"}], ";"}],
    FontSize->36], 
   StyleBox[" ",
    FontSize->36], 
   StyleBox[
    RowBox[{"(*", " ", "prom\[EHacek]nn\[AAcute]", " ", "*)"}],
    FontSize->36], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "--"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]\
}]}]}]}]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"n", ",", "\"\<! = \>\"", ",", " ", 
     RowBox[{"n", "!"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "--"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]\
}]}]}]}]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"r", "=", "0"}], ";", 
    RowBox[{"ReseniAll", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sachovnice", "[", "array_", "]"}], ":=", 
     RowBox[{"(", "      ", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "tento", " ", "pattern", " ", "vykresluje", " ", "sachovnici", " ", 
         "a", " ", 
         RowBox[{"damy", ".", " ", "Sachovnice"}], " ", "se", " ", "zklada", 
         " ", "z", " ", "\[CHacek]ernych", " ", "\[CHacek]ar"}], ",", " ", 
        RowBox[{"\[CHacek]tvere\[CHacek]ku", 
         RowBox[{"(", 
          RowBox[{"\[CHacek]ernych", ",", "\[SHacek]edych"}], ")"}]}]}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Show", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{"Gray", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Rectangle", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"j", "+", "h"}], ",", "j"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"j", "+", "h", "+", "1"}], ",", 
                   RowBox[{"j", "+", "1"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "0.5", ",", 
                 RowBox[{"n", "+", "0.5"}], ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"h", ",", 
                 RowBox[{
                  RowBox[{"-", "n"}], "+", "2"}], ",", "n", ",", "2"}], 
                "}"}]}], "]"}]}], "}"}], ",", 
           RowBox[{"Frame", "\[Rule]", "False"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0.48", ",", 
                RowBox[{"n", "+", "0.51"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0.48", ",", 
                RowBox[{"n", "+", "0.51"}]}], "}"}]}], "\[IndentingNewLine]", 
             "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{"array", ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "n"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "n"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
           RowBox[{"Axes", "\[Rule]", "True"}], ",", 
           RowBox[{"PlotMarkers", "\[Rule]", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"PointSize", "[", 
                RowBox[{"1", "/", "n"}], "]"}], ",", "Black"}], "}"}], 
             "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Black", ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", 
                    RowBox[{"a", "+", "0.5"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "+", "0.5"}], ",", 
                    RowBox[{"a", "+", "0.5"}]}], "}"}]}], "}"}], "]"}]}], 
               "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"a", ",", "0", ",", "n"}], "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Black", ",", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"a", "+", "0.5"}], ",", "0.5"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"a", "+", "0.5"}], ",", 
                    RowBox[{"n", "+", "0.5"}]}], "}"}]}], "}"}], "]"}]}], 
               "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"a", ",", "0", ",", "n"}], "}"}]}], "]"}]}], "}"}], 
          "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]",
       ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "--"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]\
}]}]}]}]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"addList", "[", 
      RowBox[{"i_", ",", "j_", ",", "d_"}], "]"}], ":=", 
     RowBox[{"(", "    ", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "tato", " ", "funkce", " ", "prida", " ", "do", " ", "listu", " ", 
         "\[RHacek]adek"}], ",", " ", 
        RowBox[{"sloupec", " ", "a", " ", "diagonalu1", " ", "diagonalu2"}], 
        ",", " ", 
        RowBox[{
        "na", " ", "kterou", " ", "nesmi", " ", "zadna", " ", "dama", " ", 
         "vstoupit"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"poledam", "[", 
         RowBox[{"[", "d", "]"}], "]"}], "=", 
        RowBox[{"{", 
         RowBox[{"i", ",", "j"}], "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"lR", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"lR", ",", 
          RowBox[{"{", "i", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"lS", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"lS", ",", 
          RowBox[{"{", "j", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"lD1", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"lD1", ",", 
          RowBox[{"{", 
           RowBox[{"i", "-", "j"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"lD2", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"lD2", ",", 
          RowBox[{"{", 
           RowBox[{"i", "+", "j"}], "}"}]}], "]"}]}], ";"}], 
      "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Button", "[", 
    RowBox[{
    "\"\<Zastavit v\[YAcute]po\[CHacek]et vypnut\[IAcute]m kernelu\>\"", ",", 
     
     RowBox[{"Quit", "[", "]"}]}], "]"}], " ", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "--"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]\
}]}]}]}]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", 
    RowBox[{"sachovnice", "[", "poledam", "]"}], "]"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"k", "=", "1"}], ",", 
      RowBox[{"k", "\[LessEqual]", "n"}], ",", 
      RowBox[{"k", "++"}], ",", "  ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lR", "=", 
        RowBox[{"lS", "=", 
         RowBox[{"lD1", "=", 
          RowBox[{"lD2", "=", 
           RowBox[{"{", "}"}]}]}]}]}], ";", "         ", 
       RowBox[{"(*", " ", 
        RowBox[{"vymazani", " ", "hodnot"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"poledam", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "n"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "1"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"addList", "[", 
        RowBox[{"1", ",", "k", ",", "1"}], "]"}], ";", "          ", 
       RowBox[{"(*", 
        RowBox[{
        "posunuti", " ", "damy", " ", "o", " ", "policko", " ", "vedle", " ", 
         "a", " ", "zavolani", " ", "rekurzivni", " ", "funkce"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pridejDamu", "[", "2", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "--"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]\
}]}]}]}]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"poledam", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "n"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "1"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Pocet reseni pro \>\"", ",", "n", ",", "\"\<x\>\"", ",", "n", ",", 
      "\"\< matici je: \>\"", ",", 
      RowBox[{"Length", "[", "ReseniAll", "]"}], ",", "\[IndentingNewLine]", 
      "\"\<\\nMalinko strpeni, vykresluji reseni:\n\\n\>\""}], "]"}], ";"}], 
   " ", "\[IndentingNewLine]", 
   RowBox[{"Hyperlink", "[", 
    RowBox[{
    "\"\<Porovnani vysledku: Zdroj: Wikipedia: Proml\[EAcute]m 8 dam\>\"", 
     ",", " ", "\"\<http://cs.wikipedia.org/wiki/Probl%C3%A9m_osmi_dam\>\""}],
     "]"}], "\[IndentingNewLine]", 
   RowBox[{"sachovnice", "/@", "ReseniAll"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"vypis", " ", "reseni"}], ",", " ", 
     RowBox[{"vcetne", " ", "grafickeho", " ", "zobrazeni"}]}], "  ", "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"tst", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"!", 
      RowBox[{
       RowBox[{"Intersection", "[", 
        RowBox[{"x", ",", "y"}], "]"}], "===", 
       RowBox[{"{", "}"}]}]}]}], ";"}], "   ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"funkce", " ", "vraci", " ", 
      RowBox[{"True", "/", "false"}]}], ",", " ", 
     RowBox[{"pokud", " ", "prvek", " ", 
      RowBox[{"je", "/", "neni"}], " ", "obsazen", " ", "v", " ", "danem", 
      " ", "listu"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pridejDamu", "[", 
     RowBox[{"d_", "/;", 
      RowBox[{"d", ">", "n"}]}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"ReseniAll", "=", 
       RowBox[{"Insert", "[", 
        RowBox[{"ReseniAll", ",", "poledam", ",", 
         RowBox[{"-", "1"}]}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"Print", "[", "poledam", "]"}], "*)"}], 
      RowBox[{"r", "++"}], ";", 
      RowBox[{"Return", "[", 
       RowBox[{"-", "1"}], "]"}], ";"}], ")"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"pridejDamu", "[", "d_", "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "j"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "d"}], ",", 
          RowBox[{"i", "\[LessEqual]", "d"}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "<=", "n"}], ",", 
             RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"tst", "[", 
                   RowBox[{"lR", ",", 
                    RowBox[{"{", "i", "}"}]}], "]"}], "||", 
                  RowBox[{"tst", "[", 
                   RowBox[{"lS", ",", 
                    RowBox[{"{", "j", "}"}]}], "]"}], "||", 
                  RowBox[{"tst", "[", 
                   RowBox[{"lD1", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", "-", "j"}], "}"}]}], "]"}], "||", 
                  RowBox[{"tst", "[", 
                   RowBox[{"lD2", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", "+", "j"}], "}"}]}], "]"}]}], ")"}], ",", 
                "   ", 
                RowBox[{"(*", " ", 
                 RowBox[{"kontola", ",", " ", 
                  RowBox[{
                  "jestli", " ", "dane", " ", "policko", " ", "neni", " ", 
                   "ohrozovano", " ", "jinou", " ", "damou"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"j", "+", "i"}], ")"}], "\[Equal]", 
                    RowBox[{"2", "*", "n"}]}], ",", 
                   RowBox[{"Return", "[", 
                    RowBox[{"-", "1"}], "]"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Continue", "[", "]"}], ";"}], "\[IndentingNewLine]",
                 ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"addList", "[", 
                  RowBox[{"i", ",", "j", ",", "d"}], "]"}], ";", " ", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                   RowBox[{"policko", " ", "neni", " ", "ohrozovano"}], ",", 
                   " ", 
                   RowBox[{
                   "pridej", " ", "damu", " ", "a", " ", "pridej", " ", "do", 
                    " ", "seznamu", " ", "obsazenych", " ", "radku"}], ",", 
                   "sloupcu", ",", " ", 
                   RowBox[{"diagonaly1", ".2"}]}], " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"pridejDamu", "[", 
                    RowBox[{"d", "+", "1"}], "]"}], "<", "0"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"lR", "=", 
                    RowBox[{"Complement", "[", 
                    RowBox[{"lR", ",", 
                    RowBox[{"{", "i", "}"}]}], "]"}]}], ";", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    RowBox[{"odeber", " ", "damu"}], ",", " ", 
                    RowBox[{"vcetne", " ", "ohrozovacich", " ", "pravidel"}], 
                    ",", " ", 
                    RowBox[{
                    "protoze", " ", "ji", " ", "posuneme", " ", "o", " ", 
                    "policko", " ", "vedle"}]}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"lS", "=", 
                    RowBox[{"Complement", "[", 
                    RowBox[{"lS", ",", 
                    RowBox[{"{", "j", "}"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"lD1", "=", 
                    RowBox[{"Complement", "[", 
                    RowBox[{"lD1", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", "-", "j"}], "}"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"lD2", "=", 
                    RowBox[{"Complement", "[", 
                    RowBox[{"lD2", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", "+", "j"}], "}"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"poledam", "[", 
                    RowBox[{"[", "d", "]"}], "]"}], "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"j", "+", "i"}], ")"}], "\[Equal]", 
                    RowBox[{"2", "*", "n"}]}], ",", 
                    RowBox[{"Return", "[", 
                    RowBox[{"-", "1"}], "]"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Continue", "[", "]"}], ";"}], 
                   "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Return", "[", "0", "]"}], ";"}]}], 
                  "\[IndentingNewLine]", "]"}], ";"}]}], 
               "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Return", "[", 
            RowBox[{"-", "1"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"--", 
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", 
         RowBox[{"--", 
          RowBox[{"--", 
           RowBox[{"--", 
            RowBox[{"--", 
             RowBox[{"--", 
              RowBox[{"--", 
               RowBox[{"--", 
                RowBox[{"--", 
                 RowBox[{"--", 
                  RowBox[{"--", 
                   RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{"--", 
                    RowBox[{
                    "--", "--"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]\
}]}]}]}]}]}]}]}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.526740438523906*^9, 3.526740505020588*^9}, {
   3.52674058981372*^9, 3.526740700967627*^9}, {3.526741018295048*^9, 
   3.526741027770806*^9}, {3.526741202488998*^9, 3.526741265389285*^9}, {
   3.526741318264862*^9, 3.526741552913409*^9}, {3.526741623666074*^9, 
   3.526741875828909*^9}, {3.526741973133963*^9, 3.526742047861721*^9}, {
   3.526742093962183*^9, 3.526742320775426*^9}, {3.526743077059272*^9, 
   3.526743121962255*^9}, {3.526743218224038*^9, 3.526743334286673*^9}, {
   3.52674340059758*^9, 3.526743401565123*^9}, {3.526743437093497*^9, 
   3.526743438235484*^9}, {3.52674349757439*^9, 3.52674367925849*^9}, {
   3.526743724422359*^9, 3.526743842502243*^9}, {3.526743892986714*^9, 
   3.526743917922055*^9}, {3.526743952416352*^9, 3.526744062687066*^9}, {
   3.526744135902804*^9, 3.526744246095309*^9}, {3.526744422503965*^9, 
   3.526744469773233*^9}, {3.526744508926045*^9, 3.526744585406247*^9}, {
   3.526744615555526*^9, 3.526744822075611*^9}, {3.526744870318669*^9, 
   3.526744876475337*^9}, {3.52674492007051*^9, 3.526745071570822*^9}, {
   3.526745106361518*^9, 3.52674514827172*^9}, {3.526745178645736*^9, 
   3.526745178803082*^9}, {3.526745215343474*^9, 3.52674536152128*^9}, {
   3.526745398323626*^9, 3.526745443991423*^9}, {3.526745481695797*^9, 
   3.526745514861469*^9}, {3.52674554787385*^9, 3.526745596472526*^9}, {
   3.526745656207082*^9, 3.526745656397366*^9}, {3.526745699742537*^9, 
   3.526745820024341*^9}, {3.526745889715903*^9, 3.526745922803922*^9}, {
   3.526746024663022*^9, 3.526746061031978*^9}, {3.526746100534463*^9, 
   3.526746417690276*^9}, {3.526746454268661*^9, 3.526746501099418*^9}, {
   3.52674654783981*^9, 3.526746726866256*^9}, {3.526746801400266*^9, 
   3.526746821092249*^9}, {3.526746907750927*^9, 3.526746923123159*^9}, {
   3.526746974919703*^9, 3.526747011947766*^9}, {3.526747088851857*^9, 
   3.526747219098305*^9}, {3.526747251618718*^9, 3.526747253009506*^9}, {
   3.526747419776026*^9, 3.526747452745796*^9}, {3.526747545775494*^9, 
   3.526747571130385*^9}, {3.52674761076866*^9, 3.526747621410917*^9}, {
   3.52674776620487*^9, 3.526747825408039*^9}, {3.526747889584361*^9, 
   3.526747909376423*^9}, {3.526748060446444*^9, 3.526748100121873*^9}, {
   3.526748383743294*^9, 3.526748391952376*^9}, {3.526748432350056*^9, 
   3.526748438815877*^9}, {3.52674851689702*^9, 3.526748526374844*^9}, {
   3.52674871498929*^9, 3.526748723506841*^9}, {3.526749094829966*^9, 
   3.526749098382173*^9}, 3.526749184192448*^9, {3.526749246688314*^9, 
   3.526749249619796*^9}, 3.526749281966022*^9, {3.52674939821463*^9, 
   3.52674942773931*^9}, {3.526749457814548*^9, 3.526749572225495*^9}, {
   3.52674961533481*^9, 3.526749616084582*^9}, {3.526749708442815*^9, 
   3.526749711886736*^9}, {3.526749787930341*^9, 3.526749848328029*^9}, {
   3.526750043052487*^9, 3.526750048763308*^9}, {3.526751989013242*^9, 
   3.526752061809477*^9}, {3.526752096466252*^9, 3.526752101274342*^9}, {
   3.526752136958855*^9, 3.526752137068858*^9}, {3.526752216856527*^9, 
   3.526752220574482*^9}, {3.526752253670371*^9, 3.526752283768365*^9}, 
   3.526752461383502*^9, {3.526752584865047*^9, 3.526752586776012*^9}, 
   3.526752956952236*^9, {3.526753188389353*^9, 3.526753218627099*^9}, {
   3.526753440181964*^9, 3.526753469978185*^9}, {3.52675359295162*^9, 
   3.52675359338248*^9}, {3.526753628301323*^9, 3.526753628823777*^9}, {
   3.526753664788398*^9, 3.526753768674487*^9}, {3.526753827307857*^9, 
   3.526753984406031*^9}, {3.526754017042776*^9, 3.526754041021215*^9}, {
   3.526784091680526*^9, 3.526784136439233*^9}, {3.526784184126467*^9, 
   3.52678424186063*^9}, {3.526784308850708*^9, 3.526784334723867*^9}, {
   3.526784377296103*^9, 3.526784397549808*^9}, {3.526784428315157*^9, 
   3.526784451995691*^9}, {3.526784482321781*^9, 3.526784496286135*^9}, {
   3.526784606967374*^9, 3.526784618297993*^9}, {3.526784722970743*^9, 
   3.526784771019016*^9}, {3.526784820328546*^9, 3.526784963476506*^9}, {
   3.526785019883341*^9, 3.526785022658445*^9}, {3.52678505730877*^9, 
   3.526785071750479*^9}, {3.526785114366286*^9, 3.526785168785237*^9}, {
   3.52678525748652*^9, 3.526785313082668*^9}, {3.526785420239446*^9, 
   3.526785570976274*^9}, {3.526785730646039*^9, 3.526785736246553*^9}, {
   3.526785795709262*^9, 3.526785842583941*^9}, {3.526786065994091*^9, 
   3.526786338426172*^9}, {3.526786373507532*^9, 3.526786421063802*^9}, {
   3.52678648800614*^9, 3.526786694168991*^9}, {3.526786795747314*^9, 
   3.526787004896109*^9}, {3.52678711564999*^9, 3.526787177902814*^9}, {
   3.526787231743775*^9, 3.526787254970567*^9}, {3.526787311910266*^9, 
   3.526787316520075*^9}, 3.526787408438197*^9, {3.526787440528643*^9, 
   3.526787442169462*^9}, {3.526787474299007*^9, 3.526787475761835*^9}, {
   3.526787567054766*^9, 3.526787780224792*^9}, {3.526787818324541*^9, 
   3.526787907881188*^9}, {3.526788061804266*^9, 3.526788074620926*^9}, {
   3.526788143150416*^9, 3.526788223895588*^9}, {3.526788256355274*^9, 
   3.526788346153164*^9}, {3.526788503747088*^9, 3.526788505068114*^9}, {
   3.526788597232284*^9, 3.526788653379186*^9}, {3.526808665031585*^9, 
   3.526808673845766*^9}, {3.526808754879733*^9, 3.526808755105694*^9}, {
   3.526808785938571*^9, 3.526808843827916*^9}, {3.526808882336315*^9, 
   3.526808882869567*^9}, {3.526808922206053*^9, 3.526809123705152*^9}, {
   3.52680917962989*^9, 3.526809179950626*^9}, {3.526809223763308*^9, 
   3.526809223973477*^9}, {3.526809272909718*^9, 3.526809302697321*^9}, {
   3.526809377586486*^9, 3.526809663615071*^9}, {3.52680972466899*^9, 
   3.526809750603297*^9}, {3.526810012891338*^9, 3.526810149597847*^9}, 
   3.526810214972928*^9, {3.526810669350453*^9, 3.526810697876475*^9}, {
   3.526810839075347*^9, 3.526810841534362*^9}, {3.526810903782095*^9, 
   3.526810948832046*^9}, {3.526810981079221*^9, 3.5268112117579*^9}, {
   3.526811245552034*^9, 3.526811245895359*^9}, {3.526811383511538*^9, 
   3.526811417598636*^9}, {3.526811452222311*^9, 3.526811453642186*^9}, 
   3.526811571668227*^9, {3.526811603567604*^9, 3.526811678069358*^9}, {
   3.526812116435305*^9, 3.526812150828108*^9}, {3.526812215640865*^9, 
   3.526812265125988*^9}, {3.526812364467504*^9, 3.526812387340491*^9}, {
   3.526812418812988*^9, 3.526812430322915*^9}, {3.526812461629881*^9, 
   3.526812488845166*^9}, {3.526812538631706*^9, 3.52681254363994*^9}, {
   3.526812584914371*^9, 3.526812624459712*^9}, {3.526812731000138*^9, 
   3.526812741017427*^9}, {3.526813328010017*^9, 3.52681333647051*^9}, {
   3.526813373570443*^9, 3.526813392560605*^9}, {3.526813439372833*^9, 
   3.526813451705632*^9}, {3.526813514110618*^9, 3.526813514992881*^9}, {
   3.526813815010984*^9, 3.526813815639749*^9}, {3.526813874708413*^9, 
   3.526813875110826*^9}, {3.526814029539013*^9, 3.52681405619118*^9}, {
   3.526814144052741*^9, 3.526814154734599*^9}, {3.526814219303539*^9, 
   3.52681427753947*^9}, {3.526814309582582*^9, 3.526814312449411*^9}, {
   3.526814412010997*^9, 3.526814573688698*^9}, {3.52681460475486*^9, 
   3.526814605066741*^9}, {3.526814663563369*^9, 3.526815060605648*^9}, {
   3.526815127415878*^9, 3.526815369825031*^9}, {3.52681547046475*^9, 
   3.526815592175782*^9}, {3.526815647805394*^9, 3.526815914665064*^9}, {
   3.526815949418564*^9, 3.526815960014579*^9}, {3.526816021567116*^9, 
   3.526816031865154*^9}, {3.526817644016237*^9, 3.526817694134186*^9}, {
   3.526817777850423*^9, 3.526817785072786*^9}, {3.526817924898321*^9, 
   3.526817926514293*^9}, {3.526818080508375*^9, 3.526818080864457*^9}, {
   3.526818125427239*^9, 3.526818165298604*^9}, {3.526818218817065*^9, 
   3.526818221913726*^9}, {3.526818261500801*^9, 3.526818262336983*^9}, 
   3.526818298702428*^9, {3.526818433496922*^9, 3.526818562618682*^9}, 
   3.526818909575972*^9, {3.526819045411423*^9, 3.526819047846946*^9}, {
   3.526819125503611*^9, 3.526819128590029*^9}, {3.526819169905321*^9, 
   3.52681918587789*^9}, {3.526819227312024*^9, 3.526819252631638*^9}, {
   3.526819337401729*^9, 3.526819363194421*^9}, {3.526819627846989*^9, 
   3.526819642570731*^9}, {3.526819783175107*^9, 3.526819790892034*^9}, {
   3.526819843326327*^9, 3.526819895236343*^9}, {3.52681994025917*^9, 
   3.526819959543656*^9}, {3.526820103162113*^9, 3.526820114917226*^9}, {
   3.526820175779229*^9, 3.526820223015239*^9}, {3.526820374309516*^9, 
   3.526820436205024*^9}, {3.526820487082045*^9, 3.526820505844753*^9}, {
   3.526824159762497*^9, 3.526824186875837*^9}, {3.526824222584652*^9, 
   3.526824222917094*^9}, {3.526824294831576*^9, 3.526824297483693*^9}, {
   3.526824521633842*^9, 3.526824547604009*^9}, {3.526824592153282*^9, 
   3.526824639777075*^9}, {3.526824705672517*^9, 3.526824760645016*^9}, {
   3.526824903225773*^9, 3.526824903544859*^9}, {3.526824936218685*^9, 
   3.526825025485827*^9}, {3.526825061122408*^9, 3.526825093173886*^9}, 
   3.526825197695347*^9, 3.526825462414504*^9, {3.526826102628369*^9, 
   3.526826173376194*^9}, {3.526826206711055*^9, 3.526826211901153*^9}, {
   3.526826256103426*^9, 3.526826275434094*^9}, {3.526826317256004*^9, 
   3.526826317452343*^9}, {3.526826403376324*^9, 3.526826432415647*^9}, {
   3.526826466533375*^9, 3.526826466662582*^9}, {3.526826706840275*^9, 
   3.526826748129244*^9}, {3.526826839302284*^9, 3.526826864334327*^9}, {
   3.52682690435624*^9, 3.526826942255651*^9}, {3.526826974088422*^9, 
   3.526827008845004*^9}, {3.526827173141128*^9, 3.526827195831183*^9}, {
   3.526827333800937*^9, 3.526827370211547*^9}, {3.526827450853219*^9, 
   3.526827551466432*^9}, {3.526827587543307*^9, 3.526827588984102*^9}, {
   3.526827621611961*^9, 3.526827629563397*^9}, {3.526827766780388*^9, 
   3.52682777754026*^9}, {3.526827963132882*^9, 3.52682796356053*^9}, {
   3.526869781105266*^9, 3.526869792017696*^9}, {3.526879494166625*^9, 
   3.526879519656036*^9}, {3.526879615354562*^9, 3.526879670023574*^9}, {
   3.52700640526102*^9, 3.527006405780178*^9}, {3.527006438116566*^9, 
   3.527006442551336*^9}, {3.527006527976011*^9, 3.527006529829108*^9}, {
   3.527006577904907*^9, 3.527006586316203*^9}, 3.527006639779351*^9, {
   3.527006679283624*^9, 3.52700668829865*^9}, {3.527006739041553*^9, 
   3.527006743901752*^9}, {3.527006780989304*^9, 3.527006829729202*^9}, {
   3.527006898500686*^9, 3.52700708341944*^9}, {3.527007192052387*^9, 
   3.527007199600149*^9}, {3.527007234884217*^9, 3.527007265912025*^9}, {
   3.527007317727689*^9, 3.527007318009135*^9}, {3.527007359811269*^9, 
   3.527007360661181*^9}, {3.527007397534555*^9, 3.527007412841595*^9}, 
   3.527008003011364*^9, 3.527008046650818*^9, {3.52700807889655*^9, 
   3.527008087960262*^9}, {3.527008164762574*^9, 3.527008164890152*^9}, {
   3.527008269471815*^9, 3.527008332798223*^9}, {3.527008364239072*^9, 
   3.527008497058147*^9}, {3.527008553230815*^9, 3.527008570325715*^9}, {
   3.527008615705673*^9, 3.52700861585557*^9}, {3.527009046403193*^9, 
   3.527009049356027*^9}, {3.527009139280263*^9, 3.527009139432137*^9}, 
   3.52700938279048*^9, {3.527009419685838*^9, 3.52700944882*^9}, {
   3.527009480573454*^9, 3.527009544645266*^9}, {3.527258962159449*^9, 
   3.527258993480466*^9}, {3.527259104538204*^9, 3.527259106972461*^9}, {
   3.528565599238769*^9, 3.528565600612698*^9}, {3.528565666017616*^9, 
   3.528565745297895*^9}, {3.528565876287916*^9, 3.528566238330738*^9}, {
   3.52856629171872*^9, 3.528566467123132*^9}, {3.528566528883044*^9, 
   3.528566550900606*^9}, {3.52888393398761*^9, 3.528883940821877*^9}, {
   3.528885356742863*^9, 3.528885377912245*^9}, {3.528885408326861*^9, 
   3.528885437245433*^9}, {3.528885896189153*^9, 3.528885914560794*^9}, {
   3.528885959907512*^9, 3.528885985578925*^9}}]
}, Open  ]]
},
WindowSize->{1333, 669},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"8.0 for Linux x86 (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 660, 14, 154, "Title"],
Cell[1242, 38, 669, 13, 87, "Subtitle"],
Cell[1914, 53, 620, 11, 68, "Text"],
Cell[2537, 66, 34990, 778, 1383, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
